<?php


namespace App\ViewModels\AgendaEspecialidade\AgendaEspecialidadeListingDisponivelViewModel;


use App\Utils\Builder;
use App\Utils\Entity;
use App\Utils\ResponseException;
use App\ViewModels\AgendaEspecialidade\AgendaEspecialidadeUpdateViewModel\AgendaEspecialidadeUpdateViewModelBuilder;

class AgendaEspecialidadeListingDisponivelViewModelBuilder implements Builder
{
    protected $id;
    protected $hora_inicio;
    protected $hora_final;

    /**
     * @param mixed $nome_especialidade
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setNomeEspecialidade($nome_especialidade)
    {
        $this->nome_especialidade = $nome_especialidade;
        return $this;
    }


    /**
     * @param mixed $id_especialidade
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setIdEspecialidade($id_especialidade)
    {
        $this->id_especialidade = $id_especialidade;
        return $this;
    }

    /**
     * @param mixed $nome_cliente
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setNomeCliente($nome_cliente)
    {
        $this->nome_cliente = $nome_cliente;
        return $this;
    }

    /**
     * @param mixed $nome_pet
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setNomePet($nome_pet)
    {
        $this->nome_pet = $nome_pet;
        return $this;
    }

    /**
     * @param mixed $id_medico
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setIdMedico($id_medico)
    {
        $this->id_medico = $id_medico;
        return $this;
    }

    /**
     * @param mixed $id_unidade
     * @return AgendaEspecialidadeListingDisponivelViewModelBuilder
     */
    public function setIdUnidade($id_unidade)
    {
        $this->id_unidade = $id_unidade;
        return $this;
    }

    public function setId(int $id): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id = $id;
        return $this;
    }

    public function setData(string $data): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->data = $data;
        return $this;
    }

    public function setHoraInicio(string $hora_inicio): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        if (preg_match(REGEX_HORARIO, $hora_inicio)) {
            $this->hora_inicio = $hora_inicio;
            return $this;
        } else {
            throw new ResponseException(['hora_inicio' => 'Horário fora do formato: ' . $hora_inicio]);
        }
    }

    public function setHoraFinal(string $hora_final): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        if (preg_match(REGEX_HORARIO, $hora_final)) {
            $this->hora_final = $hora_final;
            return $this;
        } else {
            throw new ResponseException(['hora_inicio' => 'Horário fora do formato: ' . $hora_final]);
        }
    }

    public function setIdTipoProcedimento(int $id_tipo_procedimento): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id_tipo_procedimento = $id_tipo_procedimento;
        return $this;
    }

    public function setIdAgendamento(?int $id_agendamento): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id_agendamento = $id_agendamento ?? 0;
        return $this;
    }

    public function setIdProcedimento(?int $id_procedimento): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id_procedimento = $id_procedimento ?? 0;
        return $this;
    }

    public function setTipoProcedimento(string $tipo_procedimento): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->tipo_procedimento = $tipo_procedimento;
        return $this;
    }

    public function setProcedimento(?string $procedimento): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->procedimento = $procedimento ?? '';
        return $this;
    }

    public function setIdPaciente(?int $id_paciente): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id_paciente = $id_paciente ?? 0;
        return $this;
    }
    
    public function setIdCliente(?int $id_cliente): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->id_cliente = $id_cliente ?? 0;
        return $this;
    }

    public function setCanceladoEm(String $cancelado_em): AgendaEspecialidadeListingDisponivelViewModelBuilder
    {
        $this->cancelado_em = $cancelado_em;
        return $this;
    }

    public function setIdConsulta($id_consulta)
    {
        $this->id_consulta = $id_consulta;
        return $this;
    }

    public function build()
    {
        $agenda_details_vm = new AgendaEspecialidadeListingDisponivelViewModel ();
        $agenda_details_vm->setid($this->id);
        $agenda_details_vm->sethorainicio($this->hora_inicio);
        $agenda_details_vm->sethorafinal($this->hora_final);
        return $agenda_details_vm;
    }


}